Index: /liacs/ACA2010/presentation1/presentation-rvdzwet.lyx
===================================================================
--- /liacs/ACA2010/presentation1/presentation-rvdzwet.lyx	(revision 80)
+++ /liacs/ACA2010/presentation1/presentation-rvdzwet.lyx	(revision 80)
@@ -0,0 +1,937 @@
+#LyX 1.6.5 created this file. For more info see http://www.lyx.org/
+\lyxformat 345
+\begin_document
+\begin_header
+\textclass beamer
+\begin_preamble
+\usetheme{Warsaw}
+% or ...
+
+\setbeamercovered{transparent}
+% or whatever (possibly just delete it)
+\end_preamble
+\use_default_options false
+\language english
+\inputencoding auto
+\font_roman times
+\font_sans default
+\font_typewriter default
+\font_default_family default
+\font_sc false
+\font_osf false
+\font_sf_scale 100
+\font_tt_scale 100
+
+\graphics default
+\paperfontsize default
+\spacing single
+\use_hyperref false
+\papersize default
+\use_geometry false
+\use_amsmath 2
+\use_esint 0
+\cite_engine basic
+\use_bibtopic false
+\paperorientation portrait
+\secnumdepth 2
+\tocdepth 2
+\paragraph_separation indent
+\defskip medskip
+\quotes_language english
+\papercolumns 1
+\papersides 1
+\paperpagestyle default
+\tracking_changes false
+\output_changes false
+\author "" 
+\author "" 
+\end_header
+
+\begin_body
+
+\begin_layout Standard
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+This file is a solution template for:
+\end_layout
+
+\begin_layout Itemize
+Talk at a conference/colloquium.
+ 
+\end_layout
+
+\begin_layout Itemize
+Talk length is about 20min.
+ 
+\end_layout
+
+\begin_layout Itemize
+Style is ornate.
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset Note Note
+status collapsed
+
+\begin_layout Plain Layout
+Copyright 2004 by Till Tantau <tantau@users.sourceforge.net>.
+ 
+\end_layout
+
+\begin_layout Plain Layout
+In principle, this file can be redistributed and/or modified under the terms
+ of the GNU Public License, version 2.
+ However, this file is supposed to be a template to be modified for your
+ own needs.
+ For this reason, if you use this file as a template and not specifically
+ distribute it as part of a another package/program, the author grants the
+ extra permission to freely copy and modify this file as you see fit and
+ even to delete this copyright notice.
+ 
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Title
+Architectural optimizations in databases
+\begin_inset OptArg
+status open
+
+\begin_layout Plain Layout
+Architectural optimizations in databases
+\begin_inset Note Note
+status collapsed
+
+\begin_layout Plain Layout
+optional, use only with long paper titles
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Subtitle
+Data Morhing: An Adaptive, Cache-Conscious Storage Technique
+\end_layout
+
+\begin_layout Author
+Rick van der Zwet 
+\begin_inset ERT
+status collapsed
+
+\begin_layout Plain Layout
+
+
+\backslash
+and
+\end_layout
+
+\end_inset
+
+ J.K.
+ Vis 
+\begin_inset ERT
+status open
+
+\begin_layout Plain Layout
+
+
+\backslash
+and
+\end_layout
+
+\end_inset
+
+ Others 
+\begin_inset Note Note
+status collapsed
+
+\begin_layout Itemize
+Give the names in the same order as the appear in the paper.
+ 
+\end_layout
+
+\begin_layout Itemize
+Use the 
+\begin_inset Quotes eld
+\end_inset
+
+Institute mark
+\begin_inset Quotes erd
+\end_inset
+
+ inset (
+\family sans
+Insert\SpecialChar \menuseparator
+Custom Insets\SpecialChar \menuseparator
+InstituteMark
+\family default
+) only if the authors have different affiliations.
+\end_layout
+
+\end_inset
+
+
+\begin_inset OptArg
+status open
+
+\begin_layout Plain Layout
+rvdzwet, jkvis, others
+\begin_inset Note Note
+status collapsed
+
+\begin_layout Plain Layout
+- optional, use only with lots of authors
+\end_layout
+
+\begin_layout Plain Layout
+- if there are really lots of authors, use 
+\begin_inset Quotes eld
+\end_inset
+
+Author et al.
+\begin_inset Quotes erd
+\end_inset
+
+
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Institute
+LIACS - Leiden University
+\end_layout
+
+\begin_layout Date
+Advanced Compilers and Architecturers, 2010
+\begin_inset Note Note
+status collapsed
+
+\begin_layout Itemize
+Either use conference name or its abbreviation.
+ 
+\end_layout
+
+\begin_layout Itemize
+Not really informative to the audience, more for people (including yourself)
+ who are reading the slides online
+\end_layout
+
+\end_inset
+
+
+\begin_inset OptArg
+status open
+
+\begin_layout Plain Layout
+ACA2010
+\begin_inset Note Note
+status collapsed
+
+\begin_layout Plain Layout
+optional, should be abbreviation of conference name
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+If you have a file called "institution-logo-filename.xxx", where xxx is a
+ graphic format that can be processed by latex or pdflatex, resp., then you
+ can add a logo by uncommenting the following:
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset ERT
+status open
+
+\begin_layout Plain Layout
+
+
+\backslash
+pgfdeclareimage[height=0.5cm]{institution-logo}{institution-logo-filename}
+\end_layout
+
+\begin_layout Plain Layout
+
+\end_layout
+
+\begin_layout Plain Layout
+
+
+\backslash
+logo{
+\backslash
+pgfuseimage{institution-logo}}
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+The following causes the table of contents to be shown at the beginning
+ of every subsection.
+ Delete this, if you do not want it.
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+If you wish to uncover everything in a step-wise fashion, uncomment the
+ following command:
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset ERT
+status open
+
+\begin_layout Plain Layout
+
+%
+\backslash
+beamerdefaultoverlayspecification{<+->}
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout BeginFrame
+Outline
+\end_layout
+
+\begin_layout Standard
+\begin_inset CommandInset toc
+LatexCommand tableofcontents
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+Structuring a talk is a difficult task and the following structure may not
+ be suitable.
+ Here are some rules that apply for this solution: 
+\end_layout
+
+\begin_layout Itemize
+Exactly two or three sections (other than the summary).
+ 
+\end_layout
+
+\begin_layout Itemize
+At *most* three subsections per section.
+ 
+\end_layout
+
+\begin_layout Itemize
+Talk about 30s to 2min per frame.
+ So there should be between about 15 and 30 frames, all told.
+\end_layout
+
+\begin_layout Itemize
+A conference audience is likely to know very little of what you are going
+ to talk about.
+ So *simplify*! 
+\end_layout
+
+\begin_layout Itemize
+In a 20min talk, getting the main ideas across is hard enough.
+ Leave out details, even if it means being less precise than you think necessary.
+ 
+\end_layout
+
+\begin_layout Itemize
+If you omit details that are vital to the proof/implementation, just say
+ so once.
+ Everybody will be happy with that.
+ 
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Section
+Data Morphing
+\end_layout
+
+\begin_layout Subsection
+The Basic Problem That We Studied
+\begin_inset OptArg
+status open
+
+\begin_layout Plain Layout
+Basic Problem
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout BeginFrame
+Database Storage Methods.
+\end_layout
+
+\begin_layout FrameSubtitle
+The Order Matters
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+A title should summarize the slide in an understandable fashion for anyone
+ how does not follow everything on the slide itself.
+ 
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Itemize
+Traditional Row Based, Space Oriended Storage
+\end_layout
+
+\begin_layout Itemize
+Column based, New Trend.
+ Search Oriented Storage.
+\end_layout
+
+\begin_layout Itemize
+Both has advantages and disadvantages
+\end_layout
+
+\begin_layout BeginFrame
+Row Based Storage.
+\end_layout
+
+\begin_layout Itemize
+Focused on keeping data of a related entry close to each other
+\end_layout
+
+\begin_layout Itemize
+Common implementation N-ary storage model
+\end_layout
+
+\begin_layout Itemize
+\begin_inset Tabular
+<lyxtabular version="3" rows="2" columns="3">
+<features>
+<column alignment="center" valignment="top" width="0">
+<column alignment="center" valignment="top" width="0">
+<column alignment="center" valignment="top" width="0">
+<row>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+1
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+2
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" rightline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+3
+\end_layout
+
+\end_inset
+</cell>
+</row>
+<row>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+4
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+5
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" rightline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+6
+\end_layout
+
+\end_inset
+</cell>
+</row>
+</lyxtabular>
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout BeginFrame
+Row Based Storage Engine.
+\end_layout
+
+\begin_layout Standard
+\begin_inset Graphics
+	filename system_arch.jpg
+	width 11cm
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout BeginFrame
+Column Based Storage
+\end_layout
+
+\begin_layout Itemize
+Focused on allowing fast search on attributes
+\end_layout
+
+\begin_layout Itemize
+PAX storage model used.
+\end_layout
+
+\begin_layout Itemize
+\begin_inset Tabular
+<lyxtabular version="3" rows="2" columns="3">
+<features>
+<column alignment="center" valignment="top" width="0">
+<column alignment="center" valignment="top" width="0">
+<column alignment="center" valignment="top" width="0">
+<row>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+1
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+3
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" rightline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+5
+\end_layout
+
+\end_inset
+</cell>
+</row>
+<row>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+2
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+4
+\end_layout
+
+\end_inset
+</cell>
+<cell alignment="center" valignment="top" topline="true" bottomline="true" leftline="true" rightline="true" usebox="none">
+\begin_inset Text
+
+\begin_layout Plain Layout
+6
+\end_layout
+
+\end_inset
+</cell>
+</row>
+</lyxtabular>
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Subsection
+The Approch
+\end_layout
+
+\begin_layout BeginFrame
+Definitions
+\end_layout
+
+\begin_layout Itemize
+
+\emph on
+group: 
+\emph default
+Set of attributes that are writting to consecutive memory addresses
+\end_layout
+
+\begin_layout Itemize
+
+\emph on
+partition: 
+\emph default
+Set of groups that uniquely defines the position of every attrbute in a
+ relation
+\end_layout
+
+\begin_layout Itemize
+
+\emph on
+zone: 
+\emph default
+Area of a page where all instances of a particular group are written
+\end_layout
+
+\begin_layout Itemize
+
+\emph on
+zone-record: 
+\emph default
+defines a instance of the attrbutes in a particular group
+\end_layout
+
+\begin_layout BeginFrame
+The Algoritm
+\end_layout
+
+\begin_layout Enumerate
+Calculating cache-effient storage template.
+\end_layout
+
+\begin_layout Enumerate
+Re-organizing the data into a cache-effient organization.
+\end_layout
+
+\begin_deeper
+\begin_layout Enumerate
+Static evaluation, based on heuristics
+\end_layout
+
+\begin_layout Enumerate
+Dynamic restructuring based a request recognition.
+\end_layout
+
+\end_deeper
+\begin_layout Section
+Results
+\end_layout
+
+\begin_layout Subsection
+Main Results
+\end_layout
+
+\begin_layout BeginFrame
+Conclusions and Future Work 
+\end_layout
+
+\begin_layout Itemize
+Speed-up made, but only on specific well-defined datasets.
+\end_layout
+
+\begin_layout Itemize
+Finding a general optimalisation algoritm is hard.
+\end_layout
+
+\begin_layout Itemize
+Experiments did only cover memory based databases.
+\end_layout
+
+\begin_layout Section*
+Summary
+\end_layout
+
+\begin_layout BeginFrame
+Summary
+\end_layout
+
+\begin_layout Itemize
+Data Morphing is a Promising Method.
+\end_layout
+
+\begin_layout Itemize
+Combining both Row Based Storage and Column Based Storage could lead to
+ nice speeds-up.
+\end_layout
+
+\begin_layout Itemize
+Depending which method to choose how-ever is really hard.
+\end_layout
+
+\begin_layout Standard
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+An outlook is always optional.
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Standard
+\begin_inset ERT
+status collapsed
+
+\begin_layout Plain Layout
+
+
+\backslash
+vskip0pt plus.5fill
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Itemize
+Outlook
+\end_layout
+
+\begin_deeper
+\begin_layout Itemize
+Make it scale so it also take the variable 'disk access' into count.
+\end_layout
+
+\begin_layout Itemize
+Build a framework to allow easy and proper testing for various combinations.
+\end_layout
+
+\end_deeper
+\begin_layout EndFrame
+
+\end_layout
+
+\begin_layout Section*
+\start_of_appendix
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+All of the following is optional and typically not needed.
+\end_layout
+
+\end_inset
+
+Appendix
+\end_layout
+
+\begin_layout Subsection*
+For Further Reading
+\end_layout
+
+\begin_layout BeginFrame
+\begin_inset ERT
+status collapsed
+
+\begin_layout Plain Layout
+
+[allowframebreaks]
+\end_layout
+
+\end_inset
+
+For Further Reading
+\end_layout
+
+\begin_layout Standard
+\begin_inset ERT
+status collapsed
+
+\begin_layout Plain Layout
+
+
+\backslash
+beamertemplatebookbibitems
+\end_layout
+
+\end_inset
+
+
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+Start with overview books.
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout Bibliography
+\begin_inset CommandInset bibitem
+LatexCommand bibitem
+key "DM2003"
+
+\end_inset
+
+Richard A.
+ Hankins
+\begin_inset ERT
+status collapsed
+
+\begin_layout Plain Layout
+
+
+\backslash
+newblock
+\end_layout
+
+\end_inset
+
+
+\emph on
+Data Morphing: An Adaptive, Cache-Conscious Storage Technique
+\emph default
+
+\begin_inset ERT
+status collapsed
+
+\begin_layout Plain Layout
+
+
+\backslash
+newblock
+\end_layout
+
+\end_inset
+
+ Proceedings of the 29th VLDB Conference, Berlin, Germany, 2003.
+\begin_inset ERT
+status collapsed
+
+\begin_layout Plain Layout
+
+
+\backslash
+beamertemplatearticlebibitems
+\end_layout
+
+\end_inset
+
+
+\begin_inset Note Note
+status open
+
+\begin_layout Plain Layout
+Followed by interesting articles.
+ Keep the list short.
+ 
+\end_layout
+
+\end_inset
+
+
+\end_layout
+
+\begin_layout EndFrame
+
+\end_layout
+
+\end_body
+\end_document
Index: /liacs/ACA2010/presentation1/presentation-rvdzwet.tex
===================================================================
--- /liacs/ACA2010/presentation1/presentation-rvdzwet.tex	(revision 80)
+++ /liacs/ACA2010/presentation1/presentation-rvdzwet.tex	(revision 80)
@@ -0,0 +1,223 @@
+%% LyX 1.6.5 created this file.  For more info, see http://www.lyx.org/.
+%% Do not edit unless you really know what you are doing.
+\documentclass[english]{beamer}
+\usepackage{mathptmx}
+\usepackage[T1]{fontenc}
+\usepackage[latin9]{inputenc}
+\usepackage{amsmath}
+\usepackage{graphicx}
+\usepackage{amssymb}
+
+\makeatletter
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LyX specific LaTeX commands.
+\DeclareRobustCommand*{\lyxarrow}{%
+\@ifstar
+{\leavevmode\,$\triangleleft$\,\allowbreak}
+{\leavevmode\,$\triangleright$\,\allowbreak}}
+%% Because html converters don't know tabularnewline
+\providecommand{\tabularnewline}{\\}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Textclass specific LaTeX commands.
+ % this default might be overridden by plain title style
+ \newcommand\makebeamertitle{\frame{\maketitle}}%
+ \AtBeginDocument{
+   \let\origtableofcontents=\tableofcontents
+   \def\tableofcontents{\@ifnextchar[{\origtableofcontents}{\gobbletableofcontents}}
+   \def\gobbletableofcontents#1{\origtableofcontents}
+ }
+ \makeatletter
+ \long\def\lyxframe#1{\@lyxframe#1\@lyxframestop}%
+ \def\@lyxframe{\@ifnextchar<{\@@lyxframe}{\@@lyxframe<*>}}%
+ \def\@@lyxframe<#1>{\@ifnextchar[{\@@@lyxframe<#1>}{\@@@lyxframe<#1>[]}}
+ \def\@@@lyxframe<#1>[{\@ifnextchar<{\@@@@@lyxframe<#1>[}{\@@@@lyxframe<#1>[<*>][}}
+ \def\@@@@@lyxframe<#1>[#2]{\@ifnextchar[{\@@@@lyxframe<#1>[#2]}{\@@@@lyxframe<#1>[#2][]}}
+ \long\def\@@@@lyxframe<#1>[#2][#3]#4\@lyxframestop#5\lyxframeend{%
+   \frame<#1>[#2][#3]{\frametitle{#4}#5}}
+ \makeatother
+ \def\lyxframeend{} % In case there is a superfluous frame end
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% User specified LaTeX commands.
+\usetheme{Warsaw}
+% or ...
+
+\setbeamercovered{transparent}
+% or whatever (possibly just delete it)
+
+\makeatother
+
+\usepackage{babel}
+
+\begin{document}
+
+
+
+
+
+\title[Architectural optimizations in databases]{Architectural optimizations in databases}
+
+
+\subtitle{Data Morhing: An Adaptive, Cache-Conscious Storage Technique}
+
+
+\author[rvdzwet, jkvis, others]{Rick van der Zwet \and J.K. Vis \and Others }
+
+
+\institute{LIACS - Leiden University}
+
+
+\date[ACA2010]{Advanced Compilers and Architecturers, 2010}
+
+\makebeamertitle
+
+
+\pgfdeclareimage[height=0.5cm]{institution-logo}{institution-logo-filename}
+
+\logo{\pgfuseimage{institution-logo}}
+
+
+
+
+
+%\beamerdefaultoverlayspecification{<+->}
+
+
+\lyxframeend{}\lyxframe{Outline}
+
+\tableofcontents{}
+
+
+
+
+\lyxframeend{}\section{Data Morphing}
+
+
+\lyxframeend{}\subsection[Basic Problem]{The Basic Problem That We Studied}
+
+
+\lyxframeend{}\lyxframe{Database Storage Methods.}
+
+
+\framesubtitle{The Order Matters}
+\begin{itemize}
+\item Traditional Row Based, Space Oriended Storage
+\item Column based, New Trend. Search Oriented Storage.
+\item Both has advantages and disadvantages
+\end{itemize}
+
+\lyxframeend{}\lyxframe{Row Based Storage.}
+\begin{itemize}
+\item Focused on keeping data of a related entry close to each other
+\item Common implementation N-ary storage model
+\item \begin{tabular}{|c|c|c|}
+\hline 
+1 & 2 & 3\tabularnewline
+\hline
+\hline 
+4 & 5 & 6\tabularnewline
+\hline
+\end{tabular}
+\end{itemize}
+
+\lyxframeend{}\lyxframe{Row Based Storage Engine.}
+
+\includegraphics[width=11cm]{system_arch}
+
+
+\lyxframeend{}\lyxframe{Column Based Storage}
+\begin{itemize}
+\item Focused on allowing fast search on attributes
+\item PAX storage model used.
+\item \begin{tabular}{|c|c|c|}
+\hline 
+1 & 3 & 5\tabularnewline
+\hline
+\hline 
+2 & 4 & 6\tabularnewline
+\hline
+\end{tabular}
+\end{itemize}
+
+\lyxframeend{}\subsection{The Approch}
+
+
+\lyxframeend{}\lyxframe{Definitions}
+\begin{itemize}
+\item \emph{group: }Set of attributes that are writting to consecutive memory
+addresses
+\item \emph{partition: }Set of groups that uniquely defines the position
+of every attrbute in a relation
+\item \emph{zone: }Area of a page where all instances of a particular group
+are written
+\item \emph{zone-record: }defines a instance of the attrbutes in a particular
+group
+\end{itemize}
+
+\lyxframeend{}\lyxframe{The Algoritm}
+\begin{enumerate}
+\item Calculating cache-effient storage template.
+\item Re-organizing the data into a cache-effient organization.
+
+\begin{enumerate}
+\item Static evaluation, based on heuristics
+\item Dynamic restructuring based a request recognition.
+\end{enumerate}
+\end{enumerate}
+
+\lyxframeend{}\section{Results}
+
+
+\lyxframeend{}\subsection{Main Results}
+
+
+\lyxframeend{}\lyxframe{Conclusions and Future Work }
+\begin{itemize}
+\item Speed-up made, but only on specific well-defined datasets.
+\item Finding a general optimalisation algoritm is hard.
+\item Experiments did only cover memory based databases.
+\end{itemize}
+
+\lyxframeend{}\section*{Summary}
+
+
+\lyxframeend{}\lyxframe{Summary}
+\begin{itemize}
+\item Data Morphing is a Promising Method.
+\item Combining both Row Based Storage and Column Based Storage could lead
+to nice speeds-up.
+\item Depending which method to choose how-ever is really hard.
+\end{itemize}
+
+
+\vskip0pt plus.5fill
+\begin{itemize}
+\item Outlook
+
+\begin{itemize}
+\item Make it scale so it also take the variable 'disk access' into count.
+\item Build a framework to allow easy and proper testing for various combinations.
+\end{itemize}
+\end{itemize}
+
+\lyxframeend{}
+
+\appendix
+
+\lyxframeend{}\section*{Appendix}
+
+
+\lyxframeend{}\subsection*{For Further Reading}
+
+
+\lyxframeend{}\lyxframe{[allowframebreaks]For Further Reading}
+
+\beamertemplatebookbibitems
+\begin{thebibliography}{1}
+\bibitem{DM2003}Richard A. Hankins\newblock\emph{Data Morphing:
+An Adaptive, Cache-Conscious Storage Technique}\newblock Proceedings
+of the 29th VLDB Conference, Berlin, Germany, 2003.\beamertemplatearticlebibitems
+
+\end{thebibliography}
+
+\lyxframeend{}
+\end{document}