Index: liacs/ACA2010/presentation1/presentation-rvdzwet.lyx
===================================================================
--- liacs/ACA2010/presentation1/presentation-rvdzwet.lyx	(revision 82)
+++ liacs/ACA2010/presentation1/presentation-rvdzwet.lyx	(revision 83)
@@ -82,5 +82,5 @@
 
 \begin_layout Plain Layout
-Copyright 2004 by Till Tantau <tantau@users.sourceforge.net>.
+Copyright 2004 by Till Tan tau <tantau@users.sourceforge.net>.
  
 \end_layout
@@ -128,5 +128,5 @@
 
 \begin_layout Subtitle
-Data Morhing: An Adaptive, Cache-Conscious Storage Technique
+Data Morphing: An Adaptive, Cache-Conscious Storage Technique
 \end_layout
 
@@ -179,5 +179,5 @@
 \end_inset
 
-Author et al.
+Author ET al.
 \begin_inset Quotes erd
 \end_inset
@@ -201,5 +201,5 @@
 
 \begin_layout Date
-Advanced Compilers and Architecturers, 2010
+Advanced Compilers and Architectures, 2010
 \begin_inset Note Note
 status collapsed
@@ -430,5 +430,5 @@
 
 \begin_layout Itemize
-Traditional Row Based, Space Oriended Storage
+Traditional Row Based, Space Oriented Storage
 \end_layout
 
@@ -625,5 +625,5 @@
 
 \begin_layout Subsection
-The Approch
+The Approach
 \end_layout
 
@@ -637,5 +637,5 @@
 group: 
 \emph default
-Set of attributes that are writting to consecutive memory addresses
+Set of attributes that are writing to consecutive memory addresses
 \end_layout
 
@@ -645,5 +645,5 @@
 partition: 
 \emph default
-Set of groups that uniquely defines the position of every attrbute in a
+Set of groups that uniquely defines the position of every attribute in a
  relation
 \end_layout
@@ -662,17 +662,17 @@
 zone-record: 
 \emph default
-defines a instance of the attrbutes in a particular group
+defines a instance of the attributed in a particular group
 \end_layout
 
 \begin_layout BeginFrame
-The Algoritm
+The Algorithm
 \end_layout
 
 \begin_layout Enumerate
-Calculating cache-effient storage template.
+Calculating cache-efficient storage template.
 \end_layout
 
 \begin_layout Enumerate
-Re-organizing the data into a cache-effient organization.
+Re-organizing the data into a cache-efficient organization.
 \end_layout
 
@@ -700,9 +700,9 @@
 
 \begin_layout Itemize
-Speed-up made, but only on specific well-defined datasets.
-\end_layout
-
-\begin_layout Itemize
-Finding a general optimalisation algoritm is hard.
+Speed-up made, but only on specific well-defined data-sets.
+\end_layout
+
+\begin_layout Itemize
+Finding a general optimization algorithm is hard.
 \end_layout
 
Index: liacs/ACA2010/presentation1/presentation-rvdzwet.tex
===================================================================
--- liacs/ACA2010/presentation1/presentation-rvdzwet.tex	(revision 82)
+++ liacs/ACA2010/presentation1/presentation-rvdzwet.tex	(revision 83)
@@ -58,5 +58,5 @@
 
 
-\subtitle{Data Morhing: An Adaptive, Cache-Conscious Storage Technique}
+\subtitle{Data Morphing: An Adaptive, Cache-Conscious Storage Technique}
 
 
@@ -67,5 +67,5 @@
 
 
-\date[ACA2010]{Advanced Compilers and Architecturers, 2010}
+\date[ACA2010]{Advanced Compilers and Architectures, 2010}
 
 \makebeamertitle
@@ -101,5 +101,5 @@
 \framesubtitle{The Order Matters}
 \begin{itemize}
-\item Traditional Row Based, Space Oriended Storage
+\item Traditional Row Based, Space Oriented Storage
 \item Column based, New Trend. Search Oriented Storage.
 \item Both has advantages and disadvantages
@@ -139,23 +139,23 @@
 \end{itemize}
 
-\lyxframeend{}\subsection{The Approch}
+\lyxframeend{}\subsection{The Approach}
 
 
 \lyxframeend{}\lyxframe{Definitions}
 \begin{itemize}
-\item \emph{group: }Set of attributes that are writting to consecutive memory
+\item \emph{group: }Set of attributes that are writing to consecutive memory
 addresses
 \item \emph{partition: }Set of groups that uniquely defines the position
-of every attrbute in a relation
+of every attribute in a relation
 \item \emph{zone: }Area of a page where all instances of a particular group
 are written
-\item \emph{zone-record: }defines a instance of the attrbutes in a particular
+\item \emph{zone-record: }defines a instance of the attributed in a particular
 group
 \end{itemize}
 
-\lyxframeend{}\lyxframe{The Algoritm}
+\lyxframeend{}\lyxframe{The Algorithm}
 \begin{enumerate}
-\item Calculating cache-effient storage template.
-\item Re-organizing the data into a cache-effient organization.
+\item Calculating cache-efficient storage template.
+\item Re-organizing the data into a cache-efficient organization.
 
 \begin{enumerate}
@@ -173,6 +173,6 @@
 \lyxframeend{}\lyxframe{Conclusions and Future Work }
 \begin{itemize}
-\item Speed-up made, but only on specific well-defined datasets.
-\item Finding a general optimalisation algoritm is hard.
+\item Speed-up made, but only on specific well-defined data-sets.
+\item Finding a general optimization algorithm is hard.
 \item Experiments did only cover memory based databases.
 \end{itemize}