Index: liacs/MIR2010/MIR2010-project.txt
===================================================================
--- liacs/MIR2010/MIR2010-project.txt	(revision 94)
+++ liacs/MIR2010/MIR2010-project.txt	(revision 94)
@@ -0,0 +1,40 @@
+Duedate: 6 April at noon.
+You will post your projects in this thread in a zip file. You should include both the source code and a working executable.
+
+
+Each student should work on a programming project which can be either
+
+(1) The Olympics Project - Design a program which takes as input an image and outputs a category which the image should fit into.
+i.e. You can download an image from the Winter Olympics 2010 from google, feed it to your program and your program should give a text description for at least these 3 categories: "Ski jump", "Snowboarding" and "Crowd/Audience". Optional additional categories include "Ice Hockey", "Bob Sled", and "Speed Skating". The program can be written in C, C++, Java, or Processing. It should be possible to run it on Windows XP. Higher classification accuracy and/or more categories will be given higher grades.
+
+
+(2) Special Project - If you have a strong wish to design a specific multimedia retrieval project, you can discuss it with either Bart or Michael and they will tell you if it is appropriate for this class.
+
+For those that consider doing the Olympics Project, the image database to use is attached.
+In this 'winter olympics' database you will find the following folders that contain the mandatory categories:
+cat1.crowd
+cat2.skijump
+cat3.snowboarding
+
+Also, the following optional categories have been provided:
+opt1.bobsleigh
+opt2.icehockey
+opt3.speedskating
+opt4.downhillski
+opt5.curling
+
+Each folder contains 50 images. For the optional categories, feel free to download your own images or target a different olympic winter games sports category.
+
+Your goal is to discover those image characteristics that will allow you to tell into which category an image falls. To achieve this you will thus need to calculate suitable image features. Attached to this post is a Visual Studio 6.0 C++ project that can calculate a simple color histogram from a provided image. For instance, with such a color histogram you might be able to categorize an image depending on the frequency of occurrence of certain colors. Note that to get good categorization performance the histogram will not be sufficient, so your should use your own image features as a complement, or use them instead of the histogram. The color histogram is provided to serve as a starting point.
+
+Here a simple sample project is provided that uses the color histogram descriptor (from the previous message) to determine in which of the three categories an unknown image belongs.
+
+:arrow: Click the .dsw file to open the project in Microsoft Visual Studio 6.0 C++ and compile. It should compile without any problems.
+:arrow: Run the application and select the directory where the 'winter olympics' database is located.
+:arrow: Select option 1 to calculate the descriptors.
+:arrow: Select option 2 to process the descriptors.
+:arrow: Select option 3 to load a new image and let the application determine which category it belongs to.
+
+Use one of the provided example images to verify the classification works most of the time. Note that this project is rather simple and will give decent but not excellent performance. The goal of this sample project is to inspire you to create your version of the final project that performs much better and - if time permits - looks much nicer too.
+
+Good luck!
Index: liacs/MIR2010/README.txt
===================================================================
--- liacs/MIR2010/README.txt	(revision 94)
+++ liacs/MIR2010/README.txt	(revision 94)
@@ -0,0 +1,12 @@
+[crowd] - face colour
+[skijump] - green olympics logo, straight line of leaves
+[snowboarding] - bright colour in the sky
+[icehockey] - pink floor
+[speedskating] - blue line with red dots
+[downhillski] - light blue line, red flags
+[curling] - circle pattern, green -> white -> blue
+
+
+= LICENSE =
+  - Licenses for pictures is restricted by owner (not me).
+  - License for cximage is by http://www.xdp.it/cximage.htm